
const Max_Excel5_ROWS = 65534
const Max_Excel5_COLS = 254
const Max_Excel2007_ROWS = 1048576
const Max_Excel2007_COLS = 16384
'Global variable for memory allocation

dim shared gMemHandle AS hglobal 'DWORD 'Global handle to set aside memory block

'

FUNCTION  MemAlloc(lMemSize AS LONG) AS hglobal 'DWORD
  dim  lpMem AS XLOPER PTR
 
   IF  gMemHandle = 0 THEN   gMemHandle    = cast(hglobal,GlobalAlloc(0 ,1024*60))   '60meg
 FUNCTION =  gMemHandle

 'GlobalFree  hMem
END FUNCTION
' types for storing address of pointer values
' #ifdef __FB_64BIT__
'TYPE P_ADDR AS UINT64 'pointer ref 64 bit
'#else
'TYPE P_ADDR AS UINT32 'if FB 32 bit.
'#endif

'This module contains subs and functions to READ/write an XLOPER
'containing an array with doubles(reading)
' Plus other array functions involving XLOPERS
'--------------------------------------------------------------------------
'SUB:  Read_Two_operarray
'this sub reads to single XLOPer arrays(Rows, 1 column) into
'ONE two dimensioend array
'It takes Adresses of OPER VARIABLES, arraybase, out array, Successflag, Error text
'Success returns XlBooltrue or xlBoolfalse
'--------------------------------------------------------------------------

SUB Read_Two_operarray(BYVAL PtrItem1 AS lpxloper,BYVAL PtrItem2 AS lpxloper, MAtr() AS DOUBLE,byref ArrbaseOut AS short, byref TXT AS zstring, byref Success AS short)
DIM Item1 AS lpxloper, Item2 AS lpxloper
DIM rows AS short, columns AS short

DIM i AS short


IF ptrItem1->xltype = Xlarray AND ptrItem2->xltype = Xlarray THEN
   IF ptrItem1->val.array.columns   = 1 AND  ptrItem2->val.array.columns  = 1 THEN
      IF ptrItem1->val.array.rows   =  ptrItem2->val.array.rows THEN
      Rows = ptrItem1->val.array.rows
      REDIM MATR(Rows,  2)
      ELSE
      TXT = "Rows 1 array <>  Rows 2 array "
      Success = xlboolfalse '
      EXIT SUB '
      END IF
     ELSEIF ptrItem1->val.array.rows   = 1 AND  ptrItem2->val.array.rows  = 1 THEN
      IF ptrItem1->val.array.columns   =  ptrItem2->val.array.columns THEN
      Rows = ptrItem1->val.array.columns
      REDIM MATR(Rows,  2)
      ELSE
      TXT = "Columns 1 array <>  Columns 2 array "
      Success = xlboolfalse '
      EXIT SUB '
      END IF




   ELSE
      TXT = "Arrays must be 1 x n or n x 1"
   Success = xlboolfalse '
   EXIT SUB '
   END IF
ELSEIF ptrItem1->xltype <> Xlarray OR ptrItem2->xltype <> Xlarray THEN


TXT = "Missing array"
    Success = xlboolfalse '
   EXIT SUB '
END IF
' Putting values of type double into MAtr()
'assigning addresses

Item1 = ptrItem1->val.array.lparray
Item2 = ptrItem2->val.array.lparray

FOR i = 0 TO rows - 1

   IF Item1[i].xltype <> xlnumeric OR  Item2[i].xltype <> xlnumeric THEN
      TXT = "Arrays contain non-numeric items"
            Success = Xlboolfalse
      EXIT SUB
      ELSE
      MATR(i + ArrbaseOut, 1 ) = Item1[i].val.num


      MATR(i + ArrbaseOut, 2) = Item2[i].val.num

   END IF
NEXT

'if everything goes well reurn Success
success = XlBooltrue
END SUB

'--------------------------------------------------------------------------
'SUB:  Read_one_operarray
'this sub reads one single xlOPer arrays(Rows, 1 column)or 1 row, n cols into
'one dimensioend array( n)
'It takes Adresses of OPER VARIABLE, arraybase, out array, Successflag, Error text
'Success returns XlBooltrue or xlBoolfalse
'reads 1 row * cols or rows * 1 col
'--------------------------------------------------------------------------

SUB Read_One_operarray(BYVAL PtrItem1 AS lpxloper, MAtr() AS DOUBLE,byref  ArrbaseOut AS short,byref  TXT AS zstring, byref Success AS short)
DIM Item1 AS lpxloper
DIM rows AS short, columns AS short

DIM i AS short
 Success = xlboolfalse '
IF ptrItem1->xltype = Xlarray  THEN
   IF ptrItem1->val.array.rows   = 1 AND  ptrItem1->val.array.columns  > 1 THEN
      Rows = ptrItem1->val.array.columns 'No items = cols
      REDIM MATR(Rows)
      ELSEIF ptrItem1->val.array.rows   > 1 AND  ptrItem1->val.array.columns = 1 THEN
      Rows = ptrItem1->val.array.rows
      REDIM MATR(Rows)
      ELSE
      TXT = "Array must be n x 1 or 1 x n "
      Success = xlboolfalse '
      EXIT SUB '
      END IF
    '

ELSEIF ptrItem1->xltype <> Xlarray THEN


TXT = "Missing array"
    Success = xlboolfalse '
   EXIT SUB '
END IF

' Putting values of type double into MAtr()
'assigning addresses, dimension "over" where the operarry starts
Item1 = ptrItem1->val.array.lparray


FOR i = 0 TO rows - 1
   SELECT CASE Item1[i].xltype
   CASE Xlnumeric
   MATR(i + ArrbaseOut) = Item1[i].val.num
   CASE xlEmpty_Cell
   MATR(i + ArrbaseOut) = 0
   CASE ELSE

   TXT = "Array contains non-numeric items"
        Success = Xlboolfalse
   EXIT SUB
   END SELECT
NEXT



'if everything goes well reurn Success
success = XlBooltrue
END SUB
'--------------------------------------------------------------------------
'SUB:  Read_one_Col operarray
'this sub reads one single xlOPer arrays(Rows, 1 column)or 1 row, n cols into
'one dimensioend col array( n, 1)
'It takes Adresses of xlOPER VARIABLE, arraybase, out array, Successflag, Error text
'Success returns XlBooltrue or xlBoolfalse
'reads 1 row * cols or rows * 1 col
'--------------------------------------------------------------------------

SUB Read_One_Col_operarray(BYVAL PtrItem1 AS lpxloper, MAtr() AS DOUBLE,byref  ArrbaseOut AS short, byref TXT AS zstring,byref  Success AS short)
DIM Item1 AS lpxloper
DIM rows AS short, columns AS short

DIM i AS INTEGER
 Success = xlboolfalse '
IF ptrItem1->xltype = Xlarray  THEN
   IF ptrItem1->val.array.rows   = 1 AND  ptrItem1->val.array.columns  > 1 THEN
      Rows = ptrItem1->val.array.columns 'No items = cols
      REDIM MATR(Rows,1)
      ELSEIF ptrItem1->val.array.rows   > 1 AND  ptrItem1->val.array.columns = 1 THEN
      Rows = ptrItem1->val.array.rows
      REDIM MATR(Rows,1)
      ELSE
      TXT = "Array must be n x 1 or 1 x n "
      Success = xlboolfalse '
      EXIT SUB '
      END IF
    '

ELSEIF ptrItem1->xltype <> Xlarray THEN


TXT = "Missing array"
    Success = xlboolfalse '
   EXIT SUB '
END IF

' Putting values of type double into MAtr()
'assigning addresses, dimension "over" where the operarry starts
Item1 = ptrItem1->val.array.lparray


FOR i = 0 TO rows - 1
   SELECT CASE Item1[i].xltype
   CASE Xlnumeric
   MATR(i + ArrbaseOut,1) = Item1[i].val.num
   CASE xlEmpty_Cell
   MATR(i + ArrbaseOut,1) = 0
   CASE ELSE

   TXT = "Array contains non-numeric items"
        Success = Xlboolfalse
   EXIT SUB
   END SELECT
NEXT



'if everything goes well reurn Success
success = XlBooltrue
END SUB
'--------------------------------------------------------------------------
'SUB: Make_Two_operarray
'Made 30/04/98
'Programmer: E. Dingsr
'Revised:04/06/98
'
'This sub takes an multi dimensioned(2) i array and makes it into an
'xlOPER array .
'Input is the Static Outvariable of Type OPER, # rows, # columns, Arrbase
'

'Output IS THE memory address of the static Outvariable
'
'--------------------------------------------------------------------------
SUB MAKE_TWO_operarray(byref UDT AS XLOPER, MAtr() AS DOUBLE, byref rows AS short,byref  columns AS short,byref   Arrbase AS short, byref UdtAddress AS DWORD_PTR)

'DIM Madd(rows * columns + ArrOne) AS  OPER AT memAlloc(SIZEOF(UDT) * (Rows * columns + ArrOne ))'add some more elems, just in case
 dim  Madd as lpxloper
 Madd = calloc(Rows * columns + ArrOne, SIZEOF(UDT)) 'Allocate an array and initialise all elements to zero 

DIM  AS short i, j,lb


FOR i = 0 TO Rows - 1
FOR j = 0 TO Columns - 1
Madd[i * columns + j + ArrOne].xltype = xlnumeric
 
   'Madd(i * columns + j + 1).val.num = Matr(i + arrbase + lb, j + arrbase)
   Madd[i * columns + j + ArrOne].val.num = Matr(i + arrbase + lb, j + arrbase)
   NEXT
NEXT
'get addrress of UDT

UDT.xltype = xlarray
UDT.val.array.rows = rows
UDT.val.array.columns = columns
UDT.val.array.lparray = @madd[ArrOne]
UDTaddress = CAST(DWORD_PTR,VARPTR(UDT))

END SUB
'--------------------------------------------------------------------------
'SUB: Make_Two_Header_operarray
'Made 08/06/98
'Programmer: E. Dingsr
'Revised:
'
'This sub takes an double Multi array + an ASCIIZ array of dimension 1 x n with header txt and makes it into an
'xlOPER array .
'Input is the Static Outvariable of Type xlOPER, # rows, # columns, Arrbase
'

'Output IS THE memory address of the static Outvariable
'
'--------------------------------------------------------------------------
SUB MAKE_TWO_HEADER_operarray(byref UDT AS XlOPER, MAtr() AS DOUBLE, StrMat() AS zstring * 255, byref rows AS short,byref  columns AS short, byref  Arrbase AS short,byref  UdtAddress AS DWORD_PTR)
DIM FirstX AS zstring*255
'DIM Madd(rows * columns + columns + ArrOne) AS   oper AT memAlloc(SIZEOF(UDT) * (rows * columns + columns + ArrOne ))    'add 1 more elems
dim  Madd as lpxloper
 Madd = calloc(rows * columns + columns + ArrOne, SIZEOF(UDT)) 'Allocate an array and initialise all elements to zero 

DIM AS short i , j 


DIM Xes(Columns) AS zstring * 255

I = 0

FOR J = 0 TO columns - 1
Madd[i * columns + j + ArrOne ].xltype = xlstring
 Xes(j)  = CHR(LEN(StrMAt(j)))
Madd[i * columns + j + ArrOne].val.str = lstrcat(Xes(j), StrMAt(j))
NEXT

FOR i = 1 TO Rows '- 1  ' have added one more than org NR
FOR j = 0 TO Columns - 1
Madd[i * columns + j + ArrOne ].xltype = xlnumeric

   Madd[i * columns + j + ArrOne].val.num = Matr(i + arrbase - 1, j + arrbase )  
   NEXT
NEXT

'get addrress of UDT
UDT.xltype = xlarray
UDT.val.array.rows = rows + 1
UDT.val.array.columns = columns
UDT.val.array.lparray = @madd[ArrOne]

'got to force strmat(o) on the address of lparray in UDT
 firstX = StrMat(0)
DIM MYptr AS XlOPER PTR
myPTr = UDT.val.array.lparray
Myptr->xltype = xlstring
Myptr->val.str = WritePAscalStr(FirstX)

UDTaddress = cast(DWORD_PTR,VARPTR(UDT))

END SUB

'--------------------------------------------------------------------------
'SUB: Make_One_operarray
'Made 30/04/98
'Programmer: E. Dingsr
'Revised:
'
'This sub takes an double  array of dimension n and makes it into an
'xlOPER array .
'Input is the Static Outvariable of Type OPER, no rows, no columns, Arrbase
'Txt is  of type asciiz for return messages

'Output IS THE memory address of the static Outvariable
' The sub offsets Array elemnts 16 bytes) from inaddress
'--------------------------------------------------------------------------
SUB Make_One_operarray(byref UDT AS XLOPER, MAtr() AS DOUBLE, byref  rows AS short,byref  columns AS short, byref  Arrbase AS short,byref  UdtAddress AS DWORD_PTR)

'DIM Madd(Rows * columns + ArrOne) AS oper  AT memAlloc(SIZEOF(UDT) * (Rows * columns + ArrOne ))
dim  Madd as lpxloper
 Madd = calloc(Rows * columns + ArrOne, SIZEOF(UDT)) 'Allocate an array and initialise all elements to zero
 

DIM i AS INTEGER, j AS INTEGER
UDT.xltype = xlarray

UDT.val.array.rows = rows
UDT.val.array.columns = columns
IF Rows = 1 THEN Rows = Columns
FOR i = 0 TO Rows - 1

   Madd[ i + ArrOne].xltype = xlnumeric
   Madd[ i + ArrOne].val.num = Matr(i + arrbase)

   NEXT
'get addrress of UDT

UDT.val.array.lparray = @Madd[ArrOne]
UDTaddress = cast(DWORD_PTR,VARPTR(UDT))

END SUB

SUB Make_One_Col_operarray(byref UDT AS XLOPER, MAtr() AS DOUBLE, byref  rows AS short, byref columns AS short,byref   Arrbase AS short,byref  UdtAddress AS DWORD_PTR)

'DIM Madd(Rows * columns + ArrOne) AS  oper AT memAlloc(SIZEOF(UDT) * (Rows * columns + ArrOne ))
dim  Madd as lpxloper
 Madd = calloc(Rows * columns + ArrOne, SIZEOF(UDT)) 'Allocate an array and initialise all elements to zero
DIM i AS short, j AS short
UDT.xltype = xlarray

UDT.val.array.rows = rows
UDT.val.array.columns = 1
IF Rows = 1 THEN Rows = Columns
FOR i = 0 TO Rows - 1

   Madd[ i + ArrOne].xltype = xlnumeric
   Madd[ i + ArrOne].val.num = Matr(i + arrbase,1)

   NEXT

UDT.val.array.lparray = @Madd[ArrOne]
UDTaddress = cast(DWORD_PTR,VARPTR(UDT))

END SUB
'--------------------------------------------------------------------------
'Function: Get_ArrElement
'Made 04/05/98
'Programmer: E. Dingsr
'Revised:
'This funtion takes an xlOPER of xlarray type and
'returns the address of type DWORD of the specified
'xlOPER element
'Inval must be an array
'IF row or column is out of range an OPER of Xlerror is returned
'Array element handling is  Zero based
'--------------------------------------------------------------------------

FUNCTION Get_ArrElement(BYVAL Inval AS LPXLOPER, RowEl AS short, ColumnEl AS short) AS LPXLOPER
DIM dwCalc AS LPXLOPER, Outval AS LPXLOPER, NC AS short
DIM ErrOP AS XLOPER

'if not within bounds
IF inval->val.array.columns < (ColumnEl + 1) OR inval->val.array.rows < (RowEl + 1) THEN
Errop.xltype = xlerror
Errop.val.err = xlErrNA
FUNCTION = VARPTR(Errop)
EXIT FUNCTION
END IF
dwCalc = inval->val.array.lparray 'assigner addresss to first element
'calculate the address
NC = inval->val.array.columns
Outval = @dwcalc[(RowEl * NC + ColumnEl)]
FUNCTION = Outval
END FUNCTION

'--------------------------------------------------------------------------
'Function: Get_ArrElement
'Made 15/02/2017
'Programmer: E. Dingsr
'Revised:
'This funtion takes an XLOPER12 of xlarray type and
'returns the address of type DWORD of the specified
'OPER element
'Inval must be an array
'IF row or column is out of range an OPER of Xlerror is returned
'Array element handling is  Zero based
'--------------------------------------------------------------------------

FUNCTION Get_ArrElement12(BYVAL Inval AS LPXLOPER12, RowEl AS short, ColumnEl AS short) AS LPXLOPER12
DIM dwCalc AS LPXLOPER12, Outval AS LPXLOPER12, NC AS short
DIM ErrOP AS XLOPER12

'if not within bounds
IF inval->val.array.columns < (ColumnEl + 1) OR inval->val.array.rows < (RowEl + 1) THEN
Errop.xltype = xlerror
Errop.val.err = xlErrNA
FUNCTION = VARPTR(Errop)
EXIT FUNCTION
END IF
dwCalc = inval->val.array.lparray 'assigner addresss to first element
'calculate the address
NC = inval->val.array.columns
Outval = @dwcalc[(RowEl * NC + ColumnEl)]
FUNCTION = Outval
END FUNCTION



'--------------------------------------------------------------------------
'SUB:  Read_Multioperarray
'this sub reads a multidimensioned XLOPER matrix into a Multi dimensioned Double array
'
'It takes Adresses of XLOPER VARIABLES, arraybase, out array, Successflag, Error text
'Success returns XlBooltrue or xlBoolfalse
'Matr() must be dimensioned before calling this sub
'PtrItem1 must be of Xlarray type
'--------------------------------------------------------------------------

SUB Read_Multioperarray(BYVAL PtrItem1 AS LPXLOPER,  MAtr() AS DOUBLE,byref  ArrbaseOut AS short,byref  TXT AS zstring,byref  Success AS short)
DIM Item1 AS LPXLOPER
DIM rows AS short, columns AS short
DIM Start1 AS LPXLOPER
dim llItem AS LONG
'DIM Static1 AS OPER PTR
DIM i AS INTEGER, j AS INTEGER

rows = PtrItem1->val.array.rows
columns = PtrItem1->val.array.columns

' Putting values of type double into MAtr()
'assigning address
Start1  = ptrItem1->val.array.lparray

FOR i = 0 TO rows - 1
 FOR j = 0 TO Columns - 1
  
 llItem =  (i * Columns + j)

   SELECT CASE Start1[llItem ].xltype
   CASE xlNumeric
   MATR(i + ArrbaseOut, j + ArrbaseOut ) = Start1[llItem].val.num
   CASE xlEmpty_Cell
      MATR(i + ArrbaseOut, j + ArrbaseOut ) = 0
   CASE ELSE
   TXT = "Arrays contain non-numeric items"
            Success = Xlboolfalse
      EXIT SUB
   END SELECT
NEXT
NEXT
'if everything goes well return Success
success = XlBooltrue
END SUB

'----------------------------------------------------------------
'This function returns sheetID given a
'xloper range. If range is from active sheet then
'opertype will be xlTypeSref. Then we have to coerce it into an
'xltyperef type. If range is not from active sheet then
'type is xltypeRef and just grab idsheet member from XLOPER PTR
'Returns sheetID or false

'----------------------------------------------------------------
FUNCTION GetSheetID(BYVAL xREF AS LPXLOPER,byref lRow AS LONG,byref lCol AS LONG ) AS DWORD_PTR
  DIM xInterim AS XLOPER, dwRet AS DWORD_PTR, xCell AS XLMREF PTR
 SELECT CASE xRef->xltype
     CASE xltypeSref
         'convert to an external ref and grab the sheet id
         IF  xlretsuccess = excel4( Xlcoerce OR xlIntl,BYVAL VARPTR(xInterim), 2 ,BYVAL xRef, BYVAL TempINt(xltypeRef))   THEN


             dwRet = xInterim.val.mref.idsheet
             xCell =  xInterim.val.mref.lpmref
             lrow = CLNG(xCell->reftbl(0).rwFirst)
             lCol = CLNG(xCell->reftbl(0).colFirst)
             Excel4(xlFree OR xlIntl, 0, 1, BYVAL VARPTR(xInterim))


            FUNCTION =  dwRet

             ELSE
             FUNCTION = FALSE
         END IF

      CASE xlTypeRef
            dwRet = xREf->val.mref.idsheet
            xCell =  xREf->val.mref.lpmref
            lrow = CLNG(xCell->reftbl(0).rwFirst)
            lCol = CLNG(xCell->reftbl(0).colFirst)

       FUNCTION = dwRet
     CASE ELSE
     FUNCTION = false
 END SELECT

END FUNCTION

'------------------------XLOPER12---------------------------------
'This function returns sheetID given a
'xloper12 range. If range is from active sheet then
'opertype will be xlTypeSref. Then we have to coerce it into an
'xltyperef type. If range is not from active sheet then
'type is xltypeRef and just grab idsheet member from XLOPER PTR
'Returns sheetID or false

'----------------------------------------------------------------
FUNCTION GetSheetID12(BYVAL xREF AS LPXLOPER12,byref lRow AS LONG,byref lCol AS LONG ) AS DWORD_PTR
  DIM xInterim AS XLOPER12, dwRet AS idsheet, xCell AS XLMREF12 PTR
 SELECT CASE xRef->xltype
     CASE xltypeSref
         'convert to an external ref and grab the sheet id
         IF  xlretsuccess = excel12( Xlcoerce OR xlIntl,BYVAL VARPTR(xInterim), 2 ,BYVAL xRef, BYVAL TempINt12(xltypeRef))   THEN


             dwRet = xInterim.val.mref.idsheet
             xCell = xInterim.val.mref.lpmref
             lrow = xCell->reftbl(0).rwFirst
             lCol = xCell->reftbl(0).colFirst
             Excel12(xlFree OR xlIntl, 0, 1, BYVAL VARPTR(xInterim))


            FUNCTION =  dwRet

             ELSE
             FUNCTION = FALSE
         END IF

      CASE xlTypeRef
            dwRet =xREf->val.mref.idsheet 
            xCell = xREf->val.mref.lpmref 
            lrow = xCell->reftbl(0).rwFirst
            lCol = xCell->reftbl(0).colFirst

       FUNCTION = dwRet
     CASE ELSE
     FUNCTION = false
 END SELECT

END FUNCTION

'---------------------------------------------------------------------
'This sub takes an xloper  + sheet id and makes a new cell reference
'rows and columns are 0 based in excel, A1 = row 0 and col 0
'   XLtypeRef  = external reference
'---------------------------------------------------------------------
SUB CreateCellRef(byref xRef AS XLOPER,byref  dwSheetID AS DWORD_PTR,byref  lrowfirst AS LONG,byref lrowlast AS LONG,byref lcolfirst AS LONG,byref lcolLast AS LONG,byref  lSuccsess AS LONG)

 DIM cellRef AS XLMREF PTR
 cellRef = malloc(SIZEOF(XLMREF))
   lsuccsess = TRUE

'now prepare the output reference cell
     xREF.xltype = XLtypeRef
     xREF.val.mref.idsheet  =  dwSheetID ' sheet id taken from output range
      cellref->count = 1

      cellref->reftbl(0).rwfirst = CULng(lrowfirst) 'DWORD
      cellref->reftbl(0).rwlast =  CULng(lrowlast)
      cellref->reftbl(0).colfirst = CBYTE(lcolfirst)
      cellref->reftbl(0).collast =  CBYTE(lcolLast)


      xREF.val.mref.lpmref = cellref 
      'out of sheet range
      IF cellref->reftbl(0).rwlast > 65534 OR cellref->reftbl(0).collast > 254 THEN lsuccsess = FALSE
END SUB



'--------------------XLOPER12--------------------------------------
'This sub takes an xloper12  + sheet id and makes a new cell reference
'rows and columns are 0 based in excel, A1 = row 0 and col 0

'---------------------------------------------------------------------
SUB CreateCellRef12(byref xRef AS XLOPER12,byref dwSheetID AS dword_ptr, byref lrowfirst AS LONG,byref lrowlast AS LONG,byref lcolfirst AS LONG,byref lcolLast AS LONG,byref  lSuccsess AS LONG)
 DIM cellRef AS XLMREF12  PTR
   lsuccsess = TRUE
   cellRef = malloc(SIZEOF(XLMREF12))
'now prepare the output reference cell
     xREF.xltype = XLtypeRef
     xREF.val.mref.idsheet  =  dwSheetID ' sheet id taken from output range
      cellref->count = 1

      cellref->reftbl(0).rwfirst = lrowfirst
      cellref->reftbl(0).rwlast =  lrowlast
      cellref->reftbl(0).colfirst = lcolfirst
      cellref->reftbl(0).collast =  lcolLast


      xREF.val.mref.lpmref = cellref
      'out of sheet range
      IF cellref->reftbl(0).rwlast > Max_Excel2007_ROWS OR cellref->reftbl(0).collast > Max_Excel2007_COLS THEN lsuccsess = FALSE
free(cellRef)
END SUB


'---------------------------------------------------------------------
'This sub takes an oper  + sheet id and makes a new range  reference ie. 1 row consisting of # cols
'rows and columns are 0 based in excel, A1 = row 0 and col 0

'---------------------------------------------------------------------
SUB CreateRangeRef(byref xRef AS XLOPER,byref dwSheetID AS DWORD_ptr,byref  lrowfirst AS LONG,byref lrowlast AS LONG,byref lcolfirst AS LONG,byref lcolLast AS LONG,byref  lSuccsess AS LONG)
 DIM cellRef AS XLMREF PTR
   lsuccsess = FALSE
     cellRef = malloc(SIZEOF(XLMREF))
'now prepare the output reference cell
     xREF.xltype = XLtypeRef
     xREF.val.mref.idsheet  =  cast(iDSHEET,dwSheetID) ' sheet id taken from output range
      cellref->count = 1

      cellref->reftbl(0).rwfirst = Culng(lrowfirst)  'dword
      cellref->reftbl(0).rwlast =  Culng(lrowlast)
      cellref->reftbl(0).colfirst = CBYTe(lcolfirst)
      cellref->reftbl(0).collast = CBYTe(lcolLast)


      xREF.val.mref.lpmref = cellref
      'out of sheet range
      IF cellref->reftbl(0).rwlast > 65534 OR cellref->reftbl(0).collast > 254 THEN
          lsuccsess = FALSE
      ELSE
           lsuccsess = TRUE
      END IF
      free(cellRef)
END SUB


'-----------------------------XLOPER12--------------------------
'This sub takes an xloper12  + sheet id and makes a new range  reference ie. 1 row consisting of # cols
'rows and columns are 0 based in excel, A1 = row 0 and col 0

'---------------------------------------------------------------------
SUB CreateRangeRef12(byref xRef AS XLOPER12,byref dwSheetID AS DWORD_ptr,byref  lrowfirst AS LONG,byref lrowlast AS LONG,byref lcolfirst AS LONG,byref lcolLast AS LONG,byref  lSuccsess AS LONG)
 DIM cellRef AS XLMREF12 PTR
   lsuccsess = TRUE
     cellRef = malloc(SIZEOF(XLMREF12))
'now prepare the output reference cell
     xREF.xltype = XLtypeRef
     xREF.val.mref.idsheet  =  cast(IDSHEET,dwSheetID) ' sheet id taken from output range
      cellref->count = 1

      cellref->reftbl(0).rwfirst = lrowfirst
      cellref->reftbl(0).rwlast =  lrowlast
      cellref->reftbl(0).colfirst = lcolfirst
      cellref->reftbl(0).collast = lcolLast


      xREF.val.mref.lpmref = cellref
      'out of sheet range
      IF cellref->reftbl(0).rwlast > Max_Excel2007_ROWS OR cellref->reftbl(0).collast > Max_Excel2007_COLS THEN lsuccsess = FALSE
free(cellRef)
END SUB

'----------------------------------------------------------------
'This function returns sheetID given a
'xloper range. If range is from active sheet then
'opertype will be xlTypeSref. Then we have to coerce it into an
'xltyperef type. If range is not from active sheet then
'type is xltypeRef and just grab idsheet member from XLOPER PTR
'Returns sheetID or false
'
'----------------------------------------------------------------
FUNCTION GetSheetIDPluss(BYVAL xREF AS XLOPER PTR,byref lRowFirst AS LONG,byref lRowLast AS LONG,byref lColFirst AS LONG,byref lColLast AS LONG  ) AS DWORD_PTR
  DIM xInterim AS XLOPER, dwRet AS IDSHEET, xCell AS XLMREF PTR
 SELECT CASE xRef->xltype
     CASE xltypeSref
         'convert to an external ref and grab the sheet id
         IF  xlretsuccess = excel4( Xlcoerce OR xlIntl,BYVAL VARPTR(xInterim), 2 ,BYVAL xRef, BYVAL TempINt(xltypeRef))   THEN


             dwRet = xInterim.val.mref.idsheet
             xCell =  xInterim.val.mref.lpmref
             lrowfirst = CLNG(xCell->reftbl(0).rwFirst)
             lColFirst = CLNG(xCell->reftbl(0).colFirst)
             lrowLast = CLNG(xCell->reftbl(0).rwLast)
             IF    lrowLast > MAX_EXCEL5_ROWS THEN  lrowLast = MAX_EXCEL5_ROWS
             lColLast = CLNG(xCell->reftbl(0).colLast)
             


            FUNCTION =  cast(dword_ptr,dwRet)

             ELSE
             FUNCTION = FALSE
            Excel4(xlFree OR xlIntl, 0, 1, BYVAL VARPTR(xInterim))
         END IF

      CASE xlTypeRef
            dwRet = xREf->val.mref.idsheet
            xCell =  xREf->val.mref.lpmref
            lrowFirst = CLNG(xCell->reftbl(0).rwFirst)
            lColFirst = CLNG(xCell->reftbl(0).colFirst)
            lrowLast = CLNG(xCell->reftbl(0).rwLast)
            IF    lrowLast > MAX_EXCEL5_ROWS THEN  lrowLast = MAX_EXCEL5_ROWS
            lColLast = CLNG(xCell->reftbl(0).colLast)

       FUNCTION = cast(dword_ptr,dwRet)
     CASE ELSE
     FUNCTION = false
 END SELECT

END FUNCTION


'-------------------XLOPER12------------------------------------
'This function returns sheetID given a
'xloper12 range. If range is from active sheet then
'opertype will be xlTypeSref. Then we have to coerce it into an
'xltyperef type. If range is not from active sheet then
'type is xltypeRef and just grab idsheet member from XLOPER12 PTR
'Returns sheetID or false
'
'----------------------------------------------------------------
FUNCTION GetSheetIDPluss12(BYVAL xREF AS XLOPER12 PTR,byref lRowFirst AS LONG,byref lRowLast AS LONG,byref lColFirst AS LONG,byref lColLast AS LONG  ) AS DWORD_PTR
  DIM xInterim AS XLOPER12, dwRet AS IDSHEET, xCell AS XLMREF12 PTR
 SELECT CASE xRef->xltype
     CASE xltypeSref  'range in same sheet as function
        
         'convert to an external ref and grab the sheet id
         IF  xlretsuccess = excel12( Xlcoerce OR xlIntl,BYVAL VARPTR(xInterim), 2 ,BYVAL xRef, BYVAL TempINt12(xltypeRef))   THEN
             

             dwRet = xInterim.val.mref.idsheet
             xCell =  xInterim.val.mref.lpmref
              
             lrowfirst = xCell->reftbl(0).rwFirst
             lColFirst = xCell->reftbl(0).colFirst
             lrowLast = xCell->reftbl(0).rwLast
             IF    lrowLast > Max_Excel2007_ROWS THEN  lrowLast = Max_Excel2007_ROWS
             lColLast = xCell->reftbl(0).colLast
             
              

            FUNCTION =  dwRet

             ELSE
             FUNCTION = FALSE
            Excel12(xlFree OR xlIntl, 0, 1, BYVAL VARPTR(xInterim))
         END IF

      CASE xlTypeRef 'range not in same sheet as function
        
            dwRet = xREf->val.mref.idsheet
            xCell =  xREf->val.mref.lpmref
            lrowFirst = xCell->reftbl(0).rwFirst
            lColFirst = xCell->reftbl(0).colFirst
            lrowLast = xCell->reftbl(0).rwLast
            IF    lrowLast > Max_Excel2007_ROWS THEN  lrowLast = Max_Excel2007_ROWS
            lColLast = xCell->reftbl(0).colLast

       FUNCTION = dwRet
     CASE ELSE
     FUNCTION = false
 END SELECT

END FUNCTION

'--------------------------------------------------------------------------
'SUB:  GetXLoperRefDims
'Returnes startRow, enddrow, startcol and endcol in a passed sref and sheetID
' 09/10/07
'assumes that the Sref is a matrix
'also returns true/false if passed sref vaiable is matrix or not
'--------------------------------------------------------------------------
 SUB GetXLoperRefDims(BYVAL xRef AS XLOPER PTR,byref dwSheetID AS DWORD_PTR,byref  lrowFirst AS LONG,byref lrowlast AS LONG, byref lColFirst AS LONG,byref  lColLast AS LONG,byref  bSuccess AS LONG)
 DIM xInterim AS XLOPER

dim xOUT AS XLOPER

DIM cellRef AS XLMREF PTR  , nyCellref AS  XLMREF
bSuccess = false     'default
xOut =  *xRef
 SELECT CASE xOut.xltype
            CASE xlTypeRef
                 dwSheetID =  xOut.val.mref.idsheet
                 cellRef = xOut.val.mref.lpmref
                 lrowFirst = cellRef->reftbl(0).rwFirst
                 lrowLast = cellRef->reftbl(0).rwlast
                 IF    lrowLast > MAX_EXCEL5_ROWS THEN  lrowLast = MAX_EXCEL5_ROWS
                 lColFirst =  cellRef->reftbl(0).colfirst
                  lColLast =  cellRef->reftbl(0).collast
                 bSuccess = true
            CASE xlTypeSRef
             'convert to an external ref and grab the sheet id  xlTypeRef
                excel4( Xlcoerce OR xlIntl,BYVAL VARPTR(xINterim ), 2 ,BYVAL VARPTR(xOUT) , BYVAL TempINt(xltypeRef))
                 xOUT =   xINterim

                dwSheetID =  xOUT.val.mref.idsheet
                 cellRef = xOUT.val.mref.lpmref
                 lrowFirst = cellRef->reftbl(0).rwFirst
               lrowLast = cellRef->reftbl(0).rwlast
           IF    lrowLast > MAX_EXCEL5_ROWS THEN  lrowLast = MAX_EXCEL5_ROWS
             lColFirst =  cellRef->reftbl(0).colfirst
             lColLast =  cellRef->reftbl(0).collast
                 Excel4 xlFree OR Xlintl, 0, 1, BYVAL VARPTR(xInterim)
               bSuccess = true
  END SELECT



 END  SUB
'--------------------------------------------------------------------------
'SUB:  CreateSubXLOPERArray
'this sub reads a multidimensioned XLOPER sref and returns a sub column
'reference XLOPER
' 09/10/07
'assumes that the ref is a matrix

'--------------------------------------------------------------------------
SUB CreateSubXLOPERArray(BYVAL xIN AS LPXLOPER,byref xOUT AS XLOPER ,byref  lCOl AS LONG)
DIM xInterim AS XLOPER
dim dwSheet AS IDSHEET 'dword_ptr 
DIM  as long lrowFirst,lrowlast, lColFirst,lret
DIM cellRef AS XLMREF PTR  , nyCellref AS  XLMREF

'local inFirst as long,inlast as long
'copy values
  xOUT = *xIN
           
  SELECT CASE xout.xltype
            CASE xlTypeRef
             dwSheet =  xOUT.val.mref.idsheet
             cellRef = xOUT.val.mref.lpmref
             lrowFirst = cellRef->reftbl(0).rwFirst
             lrowLast = cellRef->reftbl(0).rwlast
             IF    lrowLast > MAX_EXCEL5_ROWS THEN  lrowLast = MAX_EXCEL5_ROWS
             lColFirst =  cellRef->reftbl(0).colfirst
         

            CASE xlTypeSRef
             'convert to an external ref and grab the sheet id  xlTypeRef
             
        lret= excel4( Xlcoerce OR xlIntl,BYVAL VARPTR(xINterim ), 2 ,BYVAL VARPTR(xOUT) , BYVAL TempINt(xltypeRef))
           
           xOUT =   xINterim

            dwSheet =  xOUT.val.mref.idsheet
             cellRef = xOUT.val.mref.lpmref
             lrowFirst = cellRef->reftbl(0).rwFirst
           lrowLast = cellRef->reftbl(0).rwlast
           IF    lrowLast > MAX_EXCEL5_ROWS THEN  lrowLast = MAX_EXCEL5_ROWS
             lColFirst =  cellRef->reftbl(0).colfirst
            
             Excel4(xlFree OR Xlintl, 0, 1, BYVAL VARPTR(xInterim))
           
  END SELECT

    xOUT.xltype = xlTypeRef
    xOUT.val.mref.idsheet  =  dwSheet
    nyCellref.count = 1

          nyCellref.reftbl(0).rwfirst = Culng(lrowfirst) 'dword

      nyCellref.reftbl(0).rwlast =  Culng(lrowlast)
      nyCellref.reftbl(0).colfirst = CBYTe(lcolfirst) + CBYTe(lcol) - 1
      nyCellref.reftbl(0).collast =  nyCellref.reftbl(0).colfirst
      xOUT.val.mref.lpmref = VARPTR(nyCellref)
END SUB





'---------------------XLOPER12---------------------------------------
'SUB:  CreateSubXLOPERArray
'this sub reads a multidimensioned XLOPER12 sref and returns a sub column
'reference XLOPER
' 09/10/07
'assumes that the Sref is a matrix
'--------------------------------------------------------------------------
SUB CreateSubXLOPERArray12(BYVAL xIN AS XLOPER12 PTR,byref xOUT AS XLOPER12 ,byref  lCOl AS LONG)
DIM xInterim AS XLOPER12
dim dwSheet AS idsheet '=DWORD  PTR
dim  AS LONG lrowFirst,lrowlast, lColFirst
DIM cellRef AS XLMREF12 PTR  , nyCellref AS  XLMREF12
'local inFirst as long,inlast as long
'copy values
  xOUT = *xIN

  SELECT CASE xout.xltype
            CASE xlTypeRef
             dwSheet =  xOUT.val.mref.idsheet
             cellRef = xOUT.val.mref.lpmref
             lrowFirst = cellRef->reftbl(0).rwFirst
             lrowLast = cellRef->reftbl(0).rwlast
             IF    lrowLast > Max_Excel2007_ROWS THEN  lrowLast = Max_Excel2007_ROWS
             lColFirst =  cellRef->reftbl(0).colfirst


            CASE xlTypeSRef
             'convert to an external ref and grab the sheet id  xlTypeRef
            excel12( Xlcoerce OR xlIntl,BYVAL VARPTR(xINterim ), 2 ,BYVAL VARPTR(xOUT) , BYVAL TempINt12(xltypeRef))
            xOUT =   xINterim

            dwSheet =  xOUT.val.mref.idsheet
            cellRef = xOUT.val.mref.lpmref
            lrowFirst = cellRef->reftbl(0).rwFirst
           lrowLast = cellRef->reftbl(0).rwlast
           IF    lrowLast > Max_Excel2007_ROWS THEN  lrowLast = Max_Excel2007_ROWS
             lColFirst =  cellRef->reftbl(0).colfirst

             Excel12 xlFree OR Xlintl, 0, 1, BYVAL VARPTR(xInterim)

  END SELECT

    xOUT.xltype = xlTypeRef
    xOUT.val.mref.idsheet  =  dwSheet
    nyCellref.count = 1
      nyCellref.reftbl(0).rwfirst = lrowfirst
      nyCellref.reftbl(0).rwlast =  lrowlast
      nyCellref.reftbl(0).colfirst = lcolfirst + lcol - 1
      nyCellref.reftbl(0).collast =  nyCellref.reftbl(0).colfirst
      xOUT.val.mref.lpmref = VARPTR(nyCellref)
END SUB

'---------------------XLOPER---------------------------------------
'SUB:  Xloper_val_OPERArray
'this sub reads a multidimensioned XLOPER and extracts value cells
'in specified column and returns an OPER containng an array(zero based) with found cells containing values . if not error is returned
'
' 30/10/18
' InOPERArr() is not dimensioned when passed. Sub does that
'--------------------------------------------------------------------------

SUB  Xloper_val_OPERArray(BYVAL xRange AS XLOPER PTR,byref OperArg AS XLOPER, opArr() AS XLOPER)
'STATIC UDT as   OPER
DIM  AS XLOPER xtemp,xCell
DIM  AS LONG lRowFirst,lRowLast, lColFirst,lColLast
dim AS LONG lrows, lcols,i,j,lSuccsess 
DIM Idsheet AS DWORD_PTR
DIM lCellcount AS LONG

OperArg.xltype = XlBoolean
OperArg.val.err = XlBoolFalse

SELECT CASE xRange->xltype
  CASE xlTypeRef ,xlTypeSRef
     
      'get sheet id  + rows, cols in the range area
      Idsheet = GetSheetIDPluss(BYVAL xRange,lRowFirst,lRowLast ,lColFirst,lColLast )
    
      CASE ELSE

      EXIT SUB
END SELECT
'now check if single range is single row or single column is provided. If not, give feedback
 Lrows = lRowLast - lRowFirst + 1 'zero based
 lCols = lColLast - lColFirst  + 1
IF   Lrows = 1 THEN  EXIT SUB    'need 1 column and n rows array
 'now we have to loop over and extract cells with value

  FOR j = lColFirst TO lColFirst
      FOR i = lRowFirst TO lrowLast
          CreateCellRef(xCell, idSheet, i,i,j,j,lSuccsess)
        IF lSuccsess = xlboolfalse THEN  EXIT SUB

        'just get type in cell
       IF  xlretsuccess = excel4( Xlcoerce OR xlIntl,BYVAL VARPTR(xtemp), 1 ,BYVAL VARPTR(xCell))   THEN
            IF xtemp.xltype = xlnumeric THEN
                lCellcount +=  1
                REDIM PRESERVE opArr(lCellcount)
                 opArr(lCellcount).xltype = xlNumeric
                 opArr(lCellcount).val.num = xtemp.val.num
                 
            END IF
       END IF
    NEXT
NEXT
  OperArg.xltype = XLARRAY
  OperArg.val.array.columns = 1
  OperArg.val.array.rows = lCellcount
  OperArg.val.array.lparray = VARPTR(opArr(1))


END SUB 